#include "pub/PubWrapperHelper.h"
#include "pub/PubDataWrapper.h"
#include "sub/SubWrapperHelper.h"
#include "dpc_trpc_long/executable.h"
#include "TRPCLong_GeneralWrapper.h"
#include "TRPCLong_PubDataWrapper.h"
#include "TRPCLong_SubDataWrapper.h"

GeneralWrapper::GeneralWrapper(ara::log::Logger& mainLog) :
_TRPCLong2CAN_Provide("dpc_trpc_long/dpc_trpc_long/TRPCLong2CANPPort",mainLog),
_VED2TRPCLong_Required("dpc_trpc_long/dpc_trpc_long/VED2TRPCLongRPort" ,mainLog),
_DM2TRPCLong_Required("dpc_trpc_long/dpc_trpc_long/DM2TRPCLongRPort" ,mainLog),
_EM2TRPCLongTargetsInfo_Required("dpc_trpc_long/dpc_trpc_long/EM2TRPCLongTargetsInfoRPort" ,mainLog),
_EM2TRPCLongTargetInfo_Required("dpc_trpc_long/dpc_trpc_long/EM2TRPCLongTargetInfoRPort" ,mainLog),
_EM2TRPCLongRoadEdgeInfo_Required("dpc_trpc_long/dpc_trpc_long/EM2TRPCLongRoadEdgeInfoRPort" ,mainLog),
_EM2TRPCLongLaneMarkerInfo_Required("dpc_trpc_long/dpc_trpc_long/EM2TRPCLongLaneMarkerInfoRPort" ,mainLog),
_CAN2Long_Required("dpc_trpc_long/dpc_trpc_long/CAN2LongRPort", mainLog),
_DM2LongRefLine_Required("dpc_trpc_long/dpc_trpc_long/DM2LongRefLineRPort", mainLog)

{
    _TRPCLong2CAN_Provide.Init();
    _VED2TRPCLong_Required.Init();
    _DM2TRPCLong_Required.Init();
    _EM2TRPCLongTargetsInfo_Required.Init();
    _EM2TRPCLongTargetInfo_Required.Init();
    _EM2TRPCLongRoadEdgeInfo_Required.Init();
    _EM2TRPCLongLaneMarkerInfo_Required.Init();
    _CAN2Long_Required.Init();
    _DM2LongRefLine_Required.Init();
}
GeneralWrapper::~GeneralWrapper() {
    _VED2TRPCLong_Required.Destroy();
    _DM2TRPCLong_Required.Destroy();
    _EM2TRPCLongTargetsInfo_Required.Destroy();
    _EM2TRPCLongTargetInfo_Required.Destroy();
    _EM2TRPCLongRoadEdgeInfo_Required.Destroy();
    _EM2TRPCLongLaneMarkerInfo_Required.Destroy();
    _CAN2Long_Required.Destroy();
    _DM2LongRefLine_Required.Destroy();
}

void GeneralWrapper::Start() {
    
}

